
_Write_74HC595:

;LCD_2x16_74HC595.c,12 :: 		void Write_74HC595(unsigned char _shiftdata)
;LCD_2x16_74HC595.c,16 :: 		valor = _shiftdata;
	MOVF       FARG_Write_74HC595__shiftdata+0, 0
	MOVWF      R4+0
;LCD_2x16_74HC595.c,17 :: 		i=8;
	MOVLW      8
	MOVWF      R2+0
	MOVLW      0
	MOVWF      R2+1
;LCD_2x16_74HC595.c,18 :: 		while (i>0)
L_Write_74HC5950:
	MOVF       R2+1, 0
	SUBLW      0
	BTFSS      STATUS+0, 2
	GOTO       L__Write_74HC59523
	MOVF       R2+0, 0
	SUBLW      0
L__Write_74HC59523:
	BTFSC      STATUS+0, 0
	GOTO       L_Write_74HC5951
;LCD_2x16_74HC595.c,20 :: 		if ((valor&0x80)==0)
	MOVLW      128
	ANDWF      R4+0, 0
	MOVWF      R1+0
	MOVF       R1+0, 0
	XORLW      0
	BTFSS      STATUS+0, 2
	GOTO       L_Write_74HC5952
;LCD_2x16_74HC595.c,22 :: 		SHIFT_DATA = 0;
	BCF        RB1_bit+0, BitPos(RB1_bit+0)
;LCD_2x16_74HC595.c,23 :: 		}
	GOTO       L_Write_74HC5953
L_Write_74HC5952:
;LCD_2x16_74HC595.c,26 :: 		SHIFT_DATA = 1;
	BSF        RB1_bit+0, BitPos(RB1_bit+0)
;LCD_2x16_74HC595.c,27 :: 		}
L_Write_74HC5953:
;LCD_2x16_74HC595.c,28 :: 		valor = valor<<1;
	RLF        R4+0, 1
	BCF        R4+0, 0
;LCD_2x16_74HC595.c,29 :: 		SHIFT_CLOCK = 1;
	BSF        RB0_bit+0, BitPos(RB0_bit+0)
;LCD_2x16_74HC595.c,30 :: 		Delay_us(1);
	NOP
	NOP
;LCD_2x16_74HC595.c,31 :: 		SHIFT_CLOCK = 0;
	BCF        RB0_bit+0, BitPos(RB0_bit+0)
;LCD_2x16_74HC595.c,32 :: 		i--;
	MOVLW      1
	SUBWF      R2+0, 1
	BTFSS      STATUS+0, 0
	DECF       R2+1, 1
;LCD_2x16_74HC595.c,33 :: 		}
	GOTO       L_Write_74HC5950
L_Write_74HC5951:
;LCD_2x16_74HC595.c,34 :: 		SHIFT_LATCH = 1;
	BSF        RB2_bit+0, BitPos(RB2_bit+0)
;LCD_2x16_74HC595.c,35 :: 		Delay_us(5);
	MOVLW      3
	MOVWF      R13+0
L_Write_74HC5954:
	DECFSZ     R13+0, 1
	GOTO       L_Write_74HC5954
;LCD_2x16_74HC595.c,36 :: 		SHIFT_LATCH = 0;
	BCF        RB2_bit+0, BitPos(RB2_bit+0)
;LCD_2x16_74HC595.c,37 :: 		Delay_us(5);
	MOVLW      3
	MOVWF      R13+0
L_Write_74HC5955:
	DECFSZ     R13+0, 1
	GOTO       L_Write_74HC5955
;LCD_2x16_74HC595.c,38 :: 		}
L_end_Write_74HC595:
	RETURN
; end of _Write_74HC595

_LCD_Command:

;LCD_2x16_74HC595.c,40 :: 		void LCD_Command (char _cmd)	/* LCD16x2 command funtion */
;LCD_2x16_74HC595.c,43 :: 		LCD_Port =(LCD_Port & 0x0F) | (_cmd & 0xF0);/* Send upper nibble */
	MOVLW      15
	ANDWF      _LCD_Port+0, 0
	MOVWF      R1+0
	MOVLW      240
	ANDWF      FARG_LCD_Command__cmd+0, 0
	MOVWF      R0+0
	MOVF       R1+0, 0
	IORWF      R0+0, 1
	MOVF       R0+0, 0
	MOVWF      _LCD_Port+0
;LCD_2x16_74HC595.c,44 :: 		Write_74HC595(LCD_Port);
	MOVF       R0+0, 0
	MOVWF      FARG_Write_74HC595__shiftdata+0
	CALL       _Write_74HC595+0
;LCD_2x16_74HC595.c,46 :: 		LCD_Port =(LCD_Port & 0xF3); // rs=0 , rw=0
	MOVLW      243
	ANDWF      _LCD_Port+0, 0
	MOVWF      R0+0
	MOVF       R0+0, 0
	MOVWF      _LCD_Port+0
;LCD_2x16_74HC595.c,47 :: 		Write_74HC595(LCD_Port);
	MOVF       R0+0, 0
	MOVWF      FARG_Write_74HC595__shiftdata+0
	CALL       _Write_74HC595+0
;LCD_2x16_74HC595.c,49 :: 		LCD_Port =(LCD_Port | 0x02);	//en=1;
	MOVLW      2
	IORWF      _LCD_Port+0, 0
	MOVWF      R0+0
	MOVF       R0+0, 0
	MOVWF      _LCD_Port+0
;LCD_2x16_74HC595.c,50 :: 		Write_74HC595(LCD_Port);
	MOVF       R0+0, 0
	MOVWF      FARG_Write_74HC595__shiftdata+0
	CALL       _Write_74HC595+0
;LCD_2x16_74HC595.c,51 :: 		delay_ms(1);
	MOVLW      3
	MOVWF      R12+0
	MOVLW      151
	MOVWF      R13+0
L_LCD_Command6:
	DECFSZ     R13+0, 1
	GOTO       L_LCD_Command6
	DECFSZ     R12+0, 1
	GOTO       L_LCD_Command6
	NOP
	NOP
;LCD_2x16_74HC595.c,52 :: 		LCD_Port =(LCD_Port & 0xFC);	//en=0;
	MOVLW      252
	ANDWF      _LCD_Port+0, 0
	MOVWF      R0+0
	MOVF       R0+0, 0
	MOVWF      _LCD_Port+0
;LCD_2x16_74HC595.c,53 :: 		Write_74HC595(LCD_Port);
	MOVF       R0+0, 0
	MOVWF      FARG_Write_74HC595__shiftdata+0
	CALL       _Write_74HC595+0
;LCD_2x16_74HC595.c,54 :: 		delay_ms(2);
	MOVLW      6
	MOVWF      R12+0
	MOVLW      48
	MOVWF      R13+0
L_LCD_Command7:
	DECFSZ     R13+0, 1
	GOTO       L_LCD_Command7
	DECFSZ     R12+0, 1
	GOTO       L_LCD_Command7
	NOP
;LCD_2x16_74HC595.c,56 :: 		LCD_Port = (LCD_Port & 0x0F) | (_cmd << 4);/* Send lower nibble */
	MOVLW      15
	ANDWF      _LCD_Port+0, 0
	MOVWF      R2+0
	MOVF       FARG_LCD_Command__cmd+0, 0
	MOVWF      R0+0
	RLF        R0+0, 1
	BCF        R0+0, 0
	RLF        R0+0, 1
	BCF        R0+0, 0
	RLF        R0+0, 1
	BCF        R0+0, 0
	RLF        R0+0, 1
	BCF        R0+0, 0
	MOVF       R2+0, 0
	IORWF      R0+0, 1
	MOVF       R0+0, 0
	MOVWF      _LCD_Port+0
;LCD_2x16_74HC595.c,57 :: 		Write_74HC595(LCD_Port);
	MOVF       R0+0, 0
	MOVWF      FARG_Write_74HC595__shiftdata+0
	CALL       _Write_74HC595+0
;LCD_2x16_74HC595.c,59 :: 		LCD_Port =(LCD_Port | 0x02);	//en=1;
	MOVLW      2
	IORWF      _LCD_Port+0, 0
	MOVWF      R0+0
	MOVF       R0+0, 0
	MOVWF      _LCD_Port+0
;LCD_2x16_74HC595.c,60 :: 		Write_74HC595(LCD_Port);
	MOVF       R0+0, 0
	MOVWF      FARG_Write_74HC595__shiftdata+0
	CALL       _Write_74HC595+0
;LCD_2x16_74HC595.c,61 :: 		delay_ms(1);
	MOVLW      3
	MOVWF      R12+0
	MOVLW      151
	MOVWF      R13+0
L_LCD_Command8:
	DECFSZ     R13+0, 1
	GOTO       L_LCD_Command8
	DECFSZ     R12+0, 1
	GOTO       L_LCD_Command8
	NOP
	NOP
;LCD_2x16_74HC595.c,62 :: 		LCD_Port =(LCD_Port & 0xFC);	//en=0;
	MOVLW      252
	ANDWF      _LCD_Port+0, 0
	MOVWF      R0+0
	MOVF       R0+0, 0
	MOVWF      _LCD_Port+0
;LCD_2x16_74HC595.c,63 :: 		Write_74HC595(LCD_Port);
	MOVF       R0+0, 0
	MOVWF      FARG_Write_74HC595__shiftdata+0
	CALL       _Write_74HC595+0
;LCD_2x16_74HC595.c,64 :: 		delay_ms(5);
	MOVLW      13
	MOVWF      R12+0
	MOVLW      251
	MOVWF      R13+0
L_LCD_Command9:
	DECFSZ     R13+0, 1
	GOTO       L_LCD_Command9
	DECFSZ     R12+0, 1
	GOTO       L_LCD_Command9
	NOP
	NOP
;LCD_2x16_74HC595.c,65 :: 		}
L_end_LCD_Command:
	RETURN
; end of _LCD_Command

_LCD_Char:

;LCD_2x16_74HC595.c,67 :: 		void LCD_Char (char char_data)  /* LCD data write function */
;LCD_2x16_74HC595.c,73 :: 		LCD_Port =(LCD_Port & 0x0F);
	MOVLW      15
	ANDWF      _LCD_Port+0, 0
	MOVWF      R0+0
	MOVF       R0+0, 0
	MOVWF      _LCD_Port+0
;LCD_2x16_74HC595.c,74 :: 		Write_74HC595(LCD_Port);
	MOVF       R0+0, 0
	MOVWF      FARG_Write_74HC595__shiftdata+0
	CALL       _Write_74HC595+0
;LCD_2x16_74HC595.c,76 :: 		LCD_Port =(LCD_Port & 0x0F) | (char_data & 0xF0);/* Send upper nibble */
	MOVLW      15
	ANDWF      _LCD_Port+0, 0
	MOVWF      R1+0
	MOVLW      240
	ANDWF      FARG_LCD_Char_char_data+0, 0
	MOVWF      R0+0
	MOVF       R1+0, 0
	IORWF      R0+0, 1
	MOVF       R0+0, 0
	MOVWF      _LCD_Port+0
;LCD_2x16_74HC595.c,77 :: 		Write_74HC595(LCD_Port);
	MOVF       R0+0, 0
	MOVWF      FARG_Write_74HC595__shiftdata+0
	CALL       _Write_74HC595+0
;LCD_2x16_74HC595.c,78 :: 		LCD_Port =(LCD_Port | 0x0A); // rs=1  en=1
	MOVLW      10
	IORWF      _LCD_Port+0, 0
	MOVWF      R0+0
	MOVF       R0+0, 0
	MOVWF      _LCD_Port+0
;LCD_2x16_74HC595.c,79 :: 		Write_74HC595(LCD_Port);
	MOVF       R0+0, 0
	MOVWF      FARG_Write_74HC595__shiftdata+0
	CALL       _Write_74HC595+0
;LCD_2x16_74HC595.c,80 :: 		LCD_Port =(LCD_Port & 0xFB); // rw=0
	MOVLW      251
	ANDWF      _LCD_Port+0, 0
	MOVWF      R0+0
	MOVF       R0+0, 0
	MOVWF      _LCD_Port+0
;LCD_2x16_74HC595.c,81 :: 		Write_74HC595(LCD_Port);
	MOVF       R0+0, 0
	MOVWF      FARG_Write_74HC595__shiftdata+0
	CALL       _Write_74HC595+0
;LCD_2x16_74HC595.c,82 :: 		LCD_Port =(LCD_Port | 0x02);	//en=1;
	MOVLW      2
	IORWF      _LCD_Port+0, 0
	MOVWF      R0+0
	MOVF       R0+0, 0
	MOVWF      _LCD_Port+0
;LCD_2x16_74HC595.c,83 :: 		Write_74HC595(LCD_Port);
	MOVF       R0+0, 0
	MOVWF      FARG_Write_74HC595__shiftdata+0
	CALL       _Write_74HC595+0
;LCD_2x16_74HC595.c,84 :: 		delay_ms(1);
	MOVLW      3
	MOVWF      R12+0
	MOVLW      151
	MOVWF      R13+0
L_LCD_Char10:
	DECFSZ     R13+0, 1
	GOTO       L_LCD_Char10
	DECFSZ     R12+0, 1
	GOTO       L_LCD_Char10
	NOP
	NOP
;LCD_2x16_74HC595.c,85 :: 		LCD_Port =(LCD_Port & 0xFC);	//en=0;
	MOVLW      252
	ANDWF      _LCD_Port+0, 0
	MOVWF      R0+0
	MOVF       R0+0, 0
	MOVWF      _LCD_Port+0
;LCD_2x16_74HC595.c,86 :: 		Write_74HC595(LCD_Port);
	MOVF       R0+0, 0
	MOVWF      FARG_Write_74HC595__shiftdata+0
	CALL       _Write_74HC595+0
;LCD_2x16_74HC595.c,87 :: 		delay_ms(2);
	MOVLW      6
	MOVWF      R12+0
	MOVLW      48
	MOVWF      R13+0
L_LCD_Char11:
	DECFSZ     R13+0, 1
	GOTO       L_LCD_Char11
	DECFSZ     R12+0, 1
	GOTO       L_LCD_Char11
	NOP
;LCD_2x16_74HC595.c,88 :: 		LCD_Port = (LCD_Port & 0x0F) | (char_data << 4);/* Send lower nibble */
	MOVLW      15
	ANDWF      _LCD_Port+0, 0
	MOVWF      R2+0
	MOVF       FARG_LCD_Char_char_data+0, 0
	MOVWF      R0+0
	RLF        R0+0, 1
	BCF        R0+0, 0
	RLF        R0+0, 1
	BCF        R0+0, 0
	RLF        R0+0, 1
	BCF        R0+0, 0
	RLF        R0+0, 1
	BCF        R0+0, 0
	MOVF       R2+0, 0
	IORWF      R0+0, 1
	MOVF       R0+0, 0
	MOVWF      _LCD_Port+0
;LCD_2x16_74HC595.c,89 :: 		Write_74HC595(LCD_Port);
	MOVF       R0+0, 0
	MOVWF      FARG_Write_74HC595__shiftdata+0
	CALL       _Write_74HC595+0
;LCD_2x16_74HC595.c,92 :: 		LCD_Port =(LCD_Port | 0x02);	//en=1;
	MOVLW      2
	IORWF      _LCD_Port+0, 0
	MOVWF      R0+0
	MOVF       R0+0, 0
	MOVWF      _LCD_Port+0
;LCD_2x16_74HC595.c,93 :: 		Write_74HC595(LCD_Port);
	MOVF       R0+0, 0
	MOVWF      FARG_Write_74HC595__shiftdata+0
	CALL       _Write_74HC595+0
;LCD_2x16_74HC595.c,94 :: 		delay_ms(1);
	MOVLW      3
	MOVWF      R12+0
	MOVLW      151
	MOVWF      R13+0
L_LCD_Char12:
	DECFSZ     R13+0, 1
	GOTO       L_LCD_Char12
	DECFSZ     R12+0, 1
	GOTO       L_LCD_Char12
	NOP
	NOP
;LCD_2x16_74HC595.c,95 :: 		LCD_Port =(LCD_Port & 0xFC);	//en=0;
	MOVLW      252
	ANDWF      _LCD_Port+0, 0
	MOVWF      R0+0
	MOVF       R0+0, 0
	MOVWF      _LCD_Port+0
;LCD_2x16_74HC595.c,96 :: 		Write_74HC595(LCD_Port);
	MOVF       R0+0, 0
	MOVWF      FARG_Write_74HC595__shiftdata+0
	CALL       _Write_74HC595+0
;LCD_2x16_74HC595.c,97 :: 		delay_ms(5);
	MOVLW      13
	MOVWF      R12+0
	MOVLW      251
	MOVWF      R13+0
L_LCD_Char13:
	DECFSZ     R13+0, 1
	GOTO       L_LCD_Char13
	DECFSZ     R12+0, 1
	GOTO       L_LCD_Char13
	NOP
	NOP
;LCD_2x16_74HC595.c,98 :: 		}
L_end_LCD_Char:
	RETURN
; end of _LCD_Char

_LCD_Char_xy:

;LCD_2x16_74HC595.c,100 :: 		void LCD_Char_xy (char row, char pos, char ch)	/* Send string to LCD function */
;LCD_2x16_74HC595.c,102 :: 		if((pos-1) == 0) LCD_command(0x80 | (row-1));
	MOVLW      1
	SUBWF      FARG_LCD_Char_xy_pos+0, 0
	MOVWF      R1+0
	CLRF       R1+1
	BTFSS      STATUS+0, 0
	DECF       R1+1, 1
	MOVLW      0
	XORWF      R1+1, 0
	BTFSS      STATUS+0, 2
	GOTO       L__LCD_Char_xy27
	MOVLW      0
	XORWF      R1+0, 0
L__LCD_Char_xy27:
	BTFSS      STATUS+0, 2
	GOTO       L_LCD_Char_xy14
	DECF       FARG_LCD_Char_xy_row+0, 0
	MOVWF      R0+0
	MOVLW      128
	IORWF      R0+0, 0
	MOVWF      FARG_LCD_Command__cmd+0
	CALL       _LCD_Command+0
	GOTO       L_LCD_Char_xy15
L_LCD_Char_xy14:
;LCD_2x16_74HC595.c,104 :: 		else  LCD_command(0x80 | 0x40 | (row-1));
	DECF       FARG_LCD_Char_xy_row+0, 0
	MOVWF      R0+0
	MOVLW      192
	IORWF      R0+0, 0
	MOVWF      FARG_LCD_Command__cmd+0
	CALL       _LCD_Command+0
L_LCD_Char_xy15:
;LCD_2x16_74HC595.c,106 :: 		LCD_Char (ch);  /* Call LCD data write */
	MOVF       FARG_LCD_Char_xy_ch+0, 0
	MOVWF      FARG_LCD_Char_char_data+0
	CALL       _LCD_Char+0
;LCD_2x16_74HC595.c,108 :: 		}
L_end_LCD_Char_xy:
	RETURN
; end of _LCD_Char_xy

_LCD_String_xy:

;LCD_2x16_74HC595.c,110 :: 		void LCD_String_xy (char row, char pos, char *str)  /* Send string to LCD function */
;LCD_2x16_74HC595.c,114 :: 		if((pos-1) == 0)   LCD_command(0x80 | (row-1));
	MOVLW      1
	SUBWF      FARG_LCD_String_xy_pos+0, 0
	MOVWF      R1+0
	CLRF       R1+1
	BTFSS      STATUS+0, 0
	DECF       R1+1, 1
	MOVLW      0
	XORWF      R1+1, 0
	BTFSS      STATUS+0, 2
	GOTO       L__LCD_String_xy29
	MOVLW      0
	XORWF      R1+0, 0
L__LCD_String_xy29:
	BTFSS      STATUS+0, 2
	GOTO       L_LCD_String_xy16
	DECF       FARG_LCD_String_xy_row+0, 0
	MOVWF      R0+0
	MOVLW      128
	IORWF      R0+0, 0
	MOVWF      FARG_LCD_Command__cmd+0
	CALL       _LCD_Command+0
	GOTO       L_LCD_String_xy17
L_LCD_String_xy16:
;LCD_2x16_74HC595.c,116 :: 		else  LCD_command(0x80 | 0x40 | (row-1));
	DECF       FARG_LCD_String_xy_row+0, 0
	MOVWF      R0+0
	MOVLW      192
	IORWF      R0+0, 0
	MOVWF      FARG_LCD_Command__cmd+0
	CALL       _LCD_Command+0
L_LCD_String_xy17:
;LCD_2x16_74HC595.c,118 :: 		for(i=0;str[i]!=0;i++)  /* Send each char of string till the NULL */
	CLRF       LCD_String_xy_i_L0+0
L_LCD_String_xy18:
	MOVF       LCD_String_xy_i_L0+0, 0
	ADDWF      FARG_LCD_String_xy_str+0, 0
	MOVWF      FSR
	MOVF       INDF+0, 0
	XORLW      0
	BTFSC      STATUS+0, 2
	GOTO       L_LCD_String_xy19
;LCD_2x16_74HC595.c,120 :: 		LCD_Char (str[i]);  /* Call LCD data write */
	MOVF       LCD_String_xy_i_L0+0, 0
	ADDWF      FARG_LCD_String_xy_str+0, 0
	MOVWF      FSR
	MOVF       INDF+0, 0
	MOVWF      FARG_LCD_Char_char_data+0
	CALL       _LCD_Char+0
;LCD_2x16_74HC595.c,118 :: 		for(i=0;str[i]!=0;i++)  /* Send each char of string till the NULL */
	INCF       LCD_String_xy_i_L0+0, 1
;LCD_2x16_74HC595.c,121 :: 		}
	GOTO       L_LCD_String_xy18
L_LCD_String_xy19:
;LCD_2x16_74HC595.c,122 :: 		}
L_end_LCD_String_xy:
	RETURN
; end of _LCD_String_xy

_LCD_Init:

;LCD_2x16_74HC595.c,124 :: 		void LCD_Init (void)		/* LCD Initialize function */
;LCD_2x16_74HC595.c,126 :: 		delay_ms(15);		/* LCD Power ON Initialization time >15ms */
	MOVLW      39
	MOVWF      R12+0
	MOVLW      245
	MOVWF      R13+0
L_LCD_Init21:
	DECFSZ     R13+0, 1
	GOTO       L_LCD_Init21
	DECFSZ     R12+0, 1
	GOTO       L_LCD_Init21
;LCD_2x16_74HC595.c,127 :: 		LCD_Command(mode_4bit);	/* 4bit mode */
	MOVLW      2
	MOVWF      FARG_LCD_Command__cmd+0
	CALL       _LCD_Command+0
;LCD_2x16_74HC595.c,128 :: 		LCD_Command(Init);	/* Initialization of 16X2 LCD in 4bit mode */
	MOVLW      40
	MOVWF      FARG_LCD_Command__cmd+0
	CALL       _LCD_Command+0
;LCD_2x16_74HC595.c,129 :: 		LCD_Command (display_on); /* Display ON Cursor OFF */
	MOVLW      12
	MOVWF      FARG_LCD_Command__cmd+0
	CALL       _LCD_Command+0
;LCD_2x16_74HC595.c,130 :: 		LCD_Command (cursor_direction_inc);/* Auto Increment cursor */
	MOVLW      6
	MOVWF      FARG_LCD_Command__cmd+0
	CALL       _LCD_Command+0
;LCD_2x16_74HC595.c,131 :: 		LCD_Command (clear_display);	/* clear display */
	MOVLW      1
	MOVWF      FARG_LCD_Command__cmd+0
	CALL       _LCD_Command+0
;LCD_2x16_74HC595.c,132 :: 		LCD_Command (home_at_cursor);	/* cursor at home position */
	MOVLW      128
	MOVWF      FARG_LCD_Command__cmd+0
	CALL       _LCD_Command+0
;LCD_2x16_74HC595.c,133 :: 		}
L_end_LCD_Init:
	RETURN
; end of _LCD_Init
