#line 1 "C:/Users/Usuario/Documents/MikroC_pro_pic/lcd_2x16_74hc595n/LCD_2x16_74HC595.c"
#line 1 "c:/users/usuario/documents/mikroc_pro_pic/lcd_2x16_74hc595n/lcd_2x16_74hc595.h"
#line 22 "c:/users/usuario/documents/mikroc_pro_pic/lcd_2x16_74hc595n/lcd_2x16_74hc595.h"
void Write_74HC595(unsigned char _shiftdata);
void LCD_Command(char _cmd);
void LCD_Char (char char_data);
void LCD_Char_xy (char row, char pos, char ch);
void LCD_String_xy (char row, char pos, char *str);
void LCD_Init (void);
#line 1 "c:/users/public/documents/mikroelektronika/mikroc pro for pic/include/built_in.h"
#line 10 "C:/Users/Usuario/Documents/MikroC_pro_pic/lcd_2x16_74hc595n/LCD_2x16_74HC595.c"
char LCD_Port=0;

void Write_74HC595(unsigned char _shiftdata)
{
unsigned int i;
unsigned char valor;
valor = _shiftdata;
i=8;
while (i>0)
{
if ((valor&0x80)==0)
{
 RB1_bit  = 0;
}
else
{
 RB1_bit  = 1;
}
valor = valor<<1;
 RB0_bit  = 1;
Delay_us(1);
 RB0_bit  = 0;
i--;
}
 RB2_bit  = 1;
Delay_us(5);
 RB2_bit  = 0;
Delay_us(5);
}

void LCD_Command (char _cmd)
{

LCD_Port =(LCD_Port & 0x0F) | (_cmd & 0xF0);
Write_74HC595(LCD_Port);

LCD_Port =(LCD_Port & 0xF3);
Write_74HC595(LCD_Port);

LCD_Port =(LCD_Port | 0x02);
Write_74HC595(LCD_Port);
delay_ms(1);
LCD_Port =(LCD_Port & 0xFC);
Write_74HC595(LCD_Port);
delay_ms(2);

LCD_Port = (LCD_Port & 0x0F) | (_cmd << 4);
Write_74HC595(LCD_Port);

LCD_Port =(LCD_Port | 0x02);
Write_74HC595(LCD_Port);
delay_ms(1);
LCD_Port =(LCD_Port & 0xFC);
Write_74HC595(LCD_Port);
delay_ms(5);
}

 void LCD_Char (char char_data)
{




 LCD_Port =(LCD_Port & 0x0F);
 Write_74HC595(LCD_Port);

 LCD_Port =(LCD_Port & 0x0F) | (char_data & 0xF0);
 Write_74HC595(LCD_Port);
 LCD_Port =(LCD_Port | 0x0A);
 Write_74HC595(LCD_Port);
 LCD_Port =(LCD_Port & 0xFB);
 Write_74HC595(LCD_Port);
 LCD_Port =(LCD_Port | 0x02);
 Write_74HC595(LCD_Port);
 delay_ms(1);
 LCD_Port =(LCD_Port & 0xFC);
 Write_74HC595(LCD_Port);
 delay_ms(2);
 LCD_Port = (LCD_Port & 0x0F) | (char_data << 4);
 Write_74HC595(LCD_Port);


 LCD_Port =(LCD_Port | 0x02);
 Write_74HC595(LCD_Port);
 delay_ms(1);
 LCD_Port =(LCD_Port & 0xFC);
 Write_74HC595(LCD_Port);
 delay_ms(5);
}

void LCD_Char_xy (char row, char pos, char ch)
{
 if((pos-1) == 0) LCD_command(0x80 | (row-1));

 else LCD_command(0x80 | 0x40 | (row-1));

 LCD_Char (ch);

}

void LCD_String_xy (char row, char pos, char *str)
{
 short int i;

 if((pos-1) == 0) LCD_command(0x80 | (row-1));

 else LCD_command(0x80 | 0x40 | (row-1));

 for(i=0;str[i]!=0;i++)
 {
 LCD_Char (str[i]);
 }
}

void LCD_Init (void)
{
 delay_ms(15);
 LCD_Command( 0x02 );
 LCD_Command( 0x28 );
 LCD_Command ( (0x08 | 0x04) );
 LCD_Command ( (0x04 | 0x02) );
 LCD_Command ( 0x01 );
 LCD_Command ( 0x80 );
}
