#ifndef __LCD_2x16_74HC595_lcd_H
#define __LCD_2x16_74HC595_lcd_H

//****************************************//*
#define clear_display                           0x01
#define mode_4bit                               0x02
#define Init                                    0x28
#define home_at_cursor                          0x80
#define cursor_direction_inc                    (0x04 | 0x02)
#define cursor_direction_dec                    (0x04 | 0x00)
#define display_shift                           (0x04 | 0x01)
#define display_no_shift                        (0x04 | 0x00)
#define display_on                              (0x08 | 0x04)
#define display_off                             (0x08 | 0x02)
#define cursor_on                               (0x08 | 0x02)
#define cursor_off                              (0x08 | 0x00)
#define blink_on                                (0x08 | 0x01)
#define blink_off                               (0x08 | 0x00)


//****************************************//*
void Write_74HC595(unsigned char _shiftdata);
void LCD_Command(char _cmd);
void LCD_Char (char char_data);
void LCD_Char_xy (char row, char pos, char ch);
void LCD_String_xy (char row, char pos, char *str);
void LCD_Init (void);

#endif