
_Set_up:

;main.c,9 :: 		void Set_up() {
;main.c,11 :: 		ANSEL = 0;
	CLRF       ANSEL+0
;main.c,12 :: 		ANSELH = 0;      // the rest of the pins set as digital Inputs or outputs.
	CLRF       ANSELH+0
;main.c,13 :: 		C1ON_bit = 0;    // analog comparators off.
	BCF        C1ON_bit+0, BitPos(C1ON_bit+0)
;main.c,14 :: 		C2ON_bit = 0;
	BCF        C2ON_bit+0, BitPos(C2ON_bit+0)
;main.c,15 :: 		TRISB=0;
	CLRF       TRISB+0
;main.c,16 :: 		PORTB=0;
	CLRF       PORTB+0
;main.c,17 :: 		LCD_Init();
	CALL       _LCD_Init+0
;main.c,18 :: 		}
L_end_Set_up:
	RETURN
; end of _Set_up

_main:

;main.c,20 :: 		void main() {
;main.c,21 :: 		Set_up();
	CALL       _Set_up+0
;main.c,22 :: 		LCD_String_xy(1, 1 ,"HELLO WORLD");
	MOVLW      1
	MOVWF      FARG_LCD_String_xy_row+0
	MOVLW      1
	MOVWF      FARG_LCD_String_xy_pos+0
	MOVLW      ?lstr1_main+0
	MOVWF      FARG_LCD_String_xy_str+0
	CALL       _LCD_String_xy+0
;main.c,23 :: 		LCD_String_xy(1, 2 ,"MONTERREY");
	MOVLW      1
	MOVWF      FARG_LCD_String_xy_row+0
	MOVLW      2
	MOVWF      FARG_LCD_String_xy_pos+0
	MOVLW      ?lstr2_main+0
	MOVWF      FARG_LCD_String_xy_str+0
	CALL       _LCD_String_xy+0
;main.c,24 :: 		delay_ms(2000);
	MOVLW      21
	MOVWF      R11+0
	MOVLW      75
	MOVWF      R12+0
	MOVLW      190
	MOVWF      R13+0
L_main0:
	DECFSZ     R13+0, 1
	GOTO       L_main0
	DECFSZ     R12+0, 1
	GOTO       L_main0
	DECFSZ     R11+0, 1
	GOTO       L_main0
	NOP
;main.c,25 :: 		LCD_Command (clear_display);
	MOVLW      1
	MOVWF      FARG_LCD_Command__cmd+0
	CALL       _LCD_Command+0
;main.c,26 :: 		LCD_String_xy(4,1,"COUNTER");
	MOVLW      4
	MOVWF      FARG_LCD_String_xy_row+0
	MOVLW      1
	MOVWF      FARG_LCD_String_xy_pos+0
	MOVLW      ?lstr3_main+0
	MOVWF      FARG_LCD_String_xy_str+0
	CALL       _LCD_String_xy+0
;main.c,27 :: 		do {
L_main1:
;main.c,28 :: 		for(count=0; count<=1000; count++) {
	CLRF       _count+0
	CLRF       _count+1
L_main4:
	MOVF       _count+1, 0
	SUBLW      3
	BTFSS      STATUS+0, 2
	GOTO       L__main14
	MOVF       _count+0, 0
	SUBLW      232
L__main14:
	BTFSS      STATUS+0, 0
	GOTO       L_main5
;main.c,29 :: 		for(env=0; env<=3; env++) {
	CLRF       _env+0
L_main7:
	MOVLW      128
	XORLW      3
	MOVWF      R0+0
	MOVLW      128
	XORWF      _env+0, 0
	SUBWF      R0+0, 0
	BTFSS      STATUS+0, 0
	GOTO       L_main8
;main.c,30 :: 		num[0] =  count/1000;
	MOVLW      232
	MOVWF      R4+0
	MOVLW      3
	MOVWF      R4+1
	MOVF       _count+0, 0
	MOVWF      R0+0
	MOVF       _count+1, 0
	MOVWF      R0+1
	CALL       _Div_16X16_U+0
	MOVF       R0+0, 0
	MOVWF      _num+0
;main.c,31 :: 		num[1] = (count/100)%10;
	MOVLW      100
	MOVWF      R4+0
	MOVLW      0
	MOVWF      R4+1
	MOVF       _count+0, 0
	MOVWF      R0+0
	MOVF       _count+1, 0
	MOVWF      R0+1
	CALL       _Div_16X16_U+0
	MOVLW      10
	MOVWF      R4+0
	MOVLW      0
	MOVWF      R4+1
	CALL       _Div_16X16_U+0
	MOVF       R8+0, 0
	MOVWF      R0+0
	MOVF       R8+1, 0
	MOVWF      R0+1
	MOVF       R0+0, 0
	MOVWF      _num+1
;main.c,32 :: 		num[2] = (count/10)%10;
	MOVLW      10
	MOVWF      R4+0
	MOVLW      0
	MOVWF      R4+1
	MOVF       _count+0, 0
	MOVWF      R0+0
	MOVF       _count+1, 0
	MOVWF      R0+1
	CALL       _Div_16X16_U+0
	MOVLW      10
	MOVWF      R4+0
	MOVLW      0
	MOVWF      R4+1
	CALL       _Div_16X16_U+0
	MOVF       R8+0, 0
	MOVWF      R0+0
	MOVF       R8+1, 0
	MOVWF      R0+1
	MOVF       R0+0, 0
	MOVWF      _num+2
;main.c,33 :: 		num[3] =  count%10;
	MOVLW      10
	MOVWF      R4+0
	MOVLW      0
	MOVWF      R4+1
	MOVF       _count+0, 0
	MOVWF      R0+0
	MOVF       _count+1, 0
	MOVWF      R0+1
	CALL       _Div_16X16_U+0
	MOVF       R8+0, 0
	MOVWF      R0+0
	MOVF       R8+1, 0
	MOVWF      R0+1
	MOVF       R0+0, 0
	MOVWF      _num+3
;main.c,34 :: 		LCD_Char_xy(aux,2,num[env]+48);
	MOVF       _aux+0, 0
	MOVWF      FARG_LCD_Char_xy_row+0
	MOVLW      2
	MOVWF      FARG_LCD_Char_xy_pos+0
	MOVF       _env+0, 0
	ADDLW      _num+0
	MOVWF      FSR
	MOVLW      48
	ADDWF      INDF+0, 0
	MOVWF      FARG_LCD_Char_xy_ch+0
	CALL       _LCD_Char_xy+0
;main.c,35 :: 		aux++;
	INCF       _aux+0, 1
;main.c,36 :: 		if(aux>8)aux=5;
	MOVF       _aux+0, 0
	SUBLW      8
	BTFSC      STATUS+0, 0
	GOTO       L_main10
	MOVLW      5
	MOVWF      _aux+0
L_main10:
;main.c,29 :: 		for(env=0; env<=3; env++) {
	INCF       _env+0, 1
;main.c,37 :: 		}
	GOTO       L_main7
L_main8:
;main.c,38 :: 		PORTB.F7=~PORTB.F7;
	MOVLW      128
	XORWF      PORTB+0, 1
;main.c,39 :: 		delay_ms(500);
	MOVLW      6
	MOVWF      R11+0
	MOVLW      19
	MOVWF      R12+0
	MOVLW      173
	MOVWF      R13+0
L_main11:
	DECFSZ     R13+0, 1
	GOTO       L_main11
	DECFSZ     R12+0, 1
	GOTO       L_main11
	DECFSZ     R11+0, 1
	GOTO       L_main11
	NOP
	NOP
;main.c,28 :: 		for(count=0; count<=1000; count++) {
	INCF       _count+0, 1
	BTFSC      STATUS+0, 2
	INCF       _count+1, 1
;main.c,40 :: 		}
	GOTO       L_main4
L_main5:
;main.c,41 :: 		} while(1);
	GOTO       L_main1
;main.c,42 :: 		}
L_end_main:
	GOTO       $+0
; end of _main
