
#include "LCD_2x16_74HC595.h"
#include "built_in.h"

unsigned int count=0;
short int env=0;
char  aux=5, num[4];

void Set_up() {

  ANSEL = 0;
  ANSELH = 0;      // the rest of the pins set as digital Inputs or outputs.
  C1ON_bit = 0;    // analog comparators off.
  C2ON_bit = 0;
  TRISB=0;
  PORTB=0;
  LCD_Init();
}

void main() {
  Set_up();
  LCD_String_xy(1, 1 ,"HELLO WORLD");
  LCD_String_xy(1, 2 ,"MONTERREY");
  delay_ms(2000);
  LCD_Command (clear_display);
  LCD_String_xy(4,1,"COUNTER");
  do {
     for(count=0; count<=1000; count++) {
        for(env=0; env<=3; env++) {
            num[0] =  count/1000;
            num[1] = (count/100)%10;
            num[2] = (count/10)%10;
            num[3] =  count%10;
             LCD_Char_xy(aux,2,num[env]+48);
            aux++;
            if(aux>8)aux=5;
      }
        PORTB.F7=~PORTB.F7;
        delay_ms(500);
     }
} while(1);
}
